/*******************************************************************************
Copyright © 2024 Sebastian Roith <https://www.roith-unterrichtet.de>

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

window.CODINGTASK = {
	"heading": "Auftrag",
	"html": "<p>Bislang enthält die Klassendefinition von <code>PERSON</code> nur alle Attribute. Vervollständige die Klassendefinition entsprechend folgender Vorgaben:</p><ul><li><p>Es soll nur einen Konstruktor geben, der die Attributewerte in derselben Reihenfolge als Parameter annimmt, in der die Attribute definiert sind, und sie den Attributen zuweist. Verwende als Parametername stets den Attributnamen.</p></li><li><p>Die Methode <code>log</code> soll einen Text der Form <code>Mustermann, Max (geboren 2000)</code> mit anschließendem Zeilenumbruch auf die Standardausgabe schreiben. Verzichte darauf, Zeichenketten zusammenzufügen, sondern verwende mehrere Aufrufe von <code>print</code> bzw. <code>println</code>.</p></li><li><p>Die Methode <code>alter</code> soll berechnen, wie alt die Person im als Parameter (Datentyp <code>int</code>) übergebenem Jahr wird, und diese Zahl zurückgeben. Falls der Methode eine Jahr vor dem Geburtsjahr übergeben wird, ergibt das natürlich ein negatives Alter.</p></li></ul><p>Programmiere den Konstruktor und die Methoden so einfach wie möglich (also ohne zusätzliche Variablen, unnötig komplexe Terme, …).</p>",
	"code": "class PERSON {\n    String nachname;\n    String vorname;\n    int geburtsjahr;\n    \n    // Konstruktor und Methoden ergänzen!\n}",
	"canReset": true,
	"labelSubmit": "📥 Klassendefinition überprüfen",
	"checkType": "json",
	"checkData": [
		{
			"part": "class",
			"name": "PERSON",
			"extends": "Object",
			"implements": [],
			"abstract": false,
			"final": false,
			"static": false,
			"content": [
				{
					"part": "attribute",
					"name": "nachname",
					"type": "String",
					"dimensions": 0,
					"static": false
				},
				{
					"part": "attribute",
					"name": "vorname",
					"type": "String",
					"dimensions": 0,
					"static": false
				},
				{
					"part": "attribute",
					"name": "geburtsjahr",
					"type": "int",
					"dimensions": 0,
					"static": false
				},
				{
					"part": "constructor",
					"dimensions": 0,
					"static": false,
					"abstract": false,
					"params": [
						{
							"part": "variable",
							"name": "nachname",
							"type": "String",
							"dimensions": 0
						},
						{
							"part": "variable",
							"name": "vorname",
							"type": "String",
							"dimensions": 0
						},
						{
							"part": "variable",
							"name": "geburtsjahr",
							"type": "int",
							"dimensions": 0
						}
					],
					"content": [
						"@this.nachname=@1;this.vorname=@2;this.geburtsjahr=@3;",
						"@this.nachname=@1;this.geburtsjahr=@3;vorname=@2;",
						"@this.vorname=@2;this.nachname=@1;this.geburtsjahr=@3;",
						"@this.vorname=@2;this.geburtsjahr=@3;this.nachname=@1;",
						"@this.geburtsjahr=@3;this.nachname=@1;this.vorname=@2;",
						"@this.geburtsjahr=@3;this.vorname=@2;this.nachname=@1;"
					]
				},
				{
					"part": "method",
					"name": "log",
					"type": "void",
					"final": false,
					"static": false,
					"params": [],
					"content": [
						" print(this.nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(this.geburtsjahr);println(\")\");",
						" print(this.nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(geburtsjahr);println(\")\");",
						" print(this.nachname);print(\", \");print(vorname);print(\" (geboren \");print(this.geburtsjahr);println(\")\");",
						" print(this.nachname);print(\", \");print(vorname);print(\" (geboren \");print(geburtsjahr);println(\")\");",
						" print(nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(this.geburtsjahr);println(\")\");",
						" print(nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(geburtsjahr);println(\")\");",
						" print(nachname);print(\", \");print(vorname);print(\" (geboren \");print(this.geburtsjahr);println(\")\");",
						" print(nachname);print(\", \");print(vorname);print(\" (geboren \");print(geburtsjahr);println(\")\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.println(\")\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.println(\")\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.println(\")\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.println(\")\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.println(\")\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.println(\")\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.println(\")\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.println(\")\");",
						" print(this.nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(this.geburtsjahr);print(\")\\n\");",
						" print(this.nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(geburtsjahr);print(\")\\n\");",
						" print(this.nachname);print(\", \");print(vorname);print(\" (geboren \");print(this.geburtsjahr);print(\")\\n\");",
						" print(this.nachname);print(\", \");print(vorname);print(\" (geboren \");print(geburtsjahr);print(\")\\n\");",
						" print(nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(this.geburtsjahr);print(\")\\n\");",
						" print(nachname);print(\", \");print(this.vorname);print(\" (geboren \");print(geburtsjahr);print(\")\\n\");",
						" print(nachname);print(\", \");print(vorname);print(\" (geboren \");print(this.geburtsjahr);print(\")\\n\");",
						" print(nachname);print(\", \");print(vorname);print(\" (geboren \");print(geburtsjahr);print(\")\\n\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(this.nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(this.vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(this.geburtsjahr);System.out.print(\")\\n\");",
						" System.out.print(nachname);System.out.print(\", \");System.out.print(vorname);System.out.print(\" (geboren \");System.out.print(geburtsjahr);System.out.print(\")\\n\");"
					]
				},
				{
					"part": "method",
					"name": "alter",
					"type": "int",
					"dimensions": 0,
					"final": false,
					"static": false,
					"params": [
						{
							"part": "variable",
							"type": "int",
							"dimensions": 0
						}
					],
					"content": [
						"@return @1 - this.geburtsjahr;",
						"@return @1 - geburtsjahr;"
					]
				}
			]
		}
	]
}
